#-----------------------------------------------------------------------
# Modified 2003 Boris Schfer <menc@noid-project>
# for the Video::Menc project
#-----------------------------------------------------------------------

#-----------------------------------------------------------------------
# Copyright (C) 2001-2002 Jrn Reder <joern@zyn.de> All Rights Reserved
# 
# This module is part of Video::DVDRip, which is free software; you can
# redistribute it and/or modify it under the same terms as Perl itself.
#-----------------------------------------------------------------------

package Video::Menc::Preset;

use base Video::Menc::Base;

use strict;
use Carp;

sub name			{ shift->{name}				}
sub title			{ shift->{title}			}
sub tc_crop_top		{ shift->{tc_crop_top}			}
sub tc_crop_bottom		{ shift->{tc_crop_bottom}		}
sub tc_crop_left		{ shift->{tc_crop_left}		}
sub tc_crop_right		{ shift->{tc_crop_right}		}
sub tc_scale_width		{ shift->{tc_scale_width}		}
sub tc_scale_height		{ shift->{tc_scale_height}		}

sub set_name			{ shift->{name}			= $_[1]	}
sub set_title			{ shift->{title}		= $_[1]	}
sub set_tc_crop_top		{ shift->{tc_crop_top}		= $_[1]	}
sub set_tc_crop_bottom		{ shift->{tc_crop_bottom}	= $_[1]	}
sub set_tc_crop_left		{ shift->{tc_crop_left}	= $_[1]	}
sub set_tc_crop_right		{ shift->{tc_crop_right}	= $_[1]	}
sub set_tc_scale_width		{ shift->{tc_scale_width}	= $_[1]	}
sub set_tc_scale_height		{ shift->{tc_scale_height}	= $_[1]	}

sub new {
	my $type = shift;
	my %par = @_;
	my  ($name, $title, $tc_scale_width, $tc_scale_height) =
	@par{'name','title','tc_scale_width','tc_scale_height'};
	my  ($tc_crop_top, $tc_crop_bottom, $tc_crop_left, $tc_crop_right) =
	@par{'tc_crop_top','tc_crop_bottom','tc_crop_left','tc_crop_right'};

	my $self = {
		name		=> $name,
		title		=> $title,
		tc_crop_top	=> $tc_crop_top,
		tc_crop_bottom	=> $tc_crop_bottom,
		tc_crop_left	=> $tc_crop_left,
		tc_crop_right	=> $tc_crop_right,
		tc_scale_width	=> $tc_scale_width,
		tc_scale_height	=> $tc_scale_height,
	};
	
	return bless $self, $type;
}

sub attributes {
	my $self = shift;
	
	my @attr = grep /^tc/, keys %{$self};
	
	return \@attr;
}

1;
